#! /bin/bash


#######################################################################
##############           PARAMETROS                ####################
#######################################################################
#*************************
#BD
#*************************
OLDIFS=IFS
MYSQL_USER="usuario"
export MYSQL_PWD="password"
MYSQL_HOST="ip/DNS"
BD="bd"

servidor_atacado=$(hostname -s)



#######################################################################
##############       EJECUTAR CONSULTA             ####################
#######################################################################
# IFS personalizado, para poder delimitar los campos correctamente
IFS="`echo -e "\t\n\r\f"`"

# Declaramos la variable como array, no es estrictamente necesario, pero sí un poco más correcto
declare -a IPS

# Generamos la consulta (Si vamos a utilizar un juego de caracteres determinado, como UTF8, debemos especificar primero para evitar sorpresas.
SQL="SET CHARACTER SET utf8; SELECT \`IP_SAE_SIGESTIC_BLIP\`,\`Fecha_Hora_SAE_SIGESTIC_BLIP\`,\`Nombre_Pais_SAE_SIGESTIC_BLIP\`,\`Organizacion_SAE_SIGESTIC_BLIP\`  FROM tab_sae_sigetic_blacklist_ips ORDER BY IP_SAE_SIGESTIC_BLIP"

# Generamos la consulta, es importante obviar los nombres de columna
IPS=(`echo "$SQL" | mysql -u $MYSQL_USER  -h $MYSQL_HOST --skip-column-names $BD`)


#######################################################################
##############       OBTENEMOS EL ARCHIVO          ####################
#######################################################################
#Obtenemos el archivo
readonly cluster_file=/etc/pve/firewall/cluster.fw

#Obtenemos el archivo del cluster y lo guardamos en la  variable
archivo_cluster=$(sed -n '/IPSET ips_blacklist/,/IPSET /p' /etc/pve/firewall/cluster.fw)


#######################################################################
##############       RECORREMOS LAS IPS            ####################
#######################################################################
printf "\n"
printf "*****************************************\n"
printf "PROCESANDO IPS... (${#IPS[@]})\n"
printf "*****************************************\n"

correo="<!DOCTYPE>"
correo="$correo<html>"
correo="$correo<head>"
correo="$correo<meta http-equiv='Content-Type' content='text/html; charset=utf-8'>"
correo="$correo<meta name='viewport' content='width=device-width, initial-scale=1'>"
correo="$correo<title>[CRON/F/$servidor_atacado]</title>"
correo="$correo<style type='text/css'>"
correo="$correo table, th, td {border: 1px solid black; padding:5px}a{text-decoration: none;}.link:hover {text-decoration: none !important;}@media screen and (min-width: 650px) {.des-pt50 {padding-top: 50px !important;}.des-pb50 {padding-bottom: 50px !important;}.des-mauto {margin: 0px !important;}.des-pb0 {padding-bottom: 0px !important;}.td, .tfoot, .thead {display: table-cell !important;}.table {display: table;	width: 100%;}}"
correo="$correo</style>"
correo="$correo</head>"
correo="$correo<body style='margin:0;padding:0;background: #F8F8F8;' id='body'>"
correo="$correo<div class='tac pt10 pb10 pl10 pr10' style='padding-top:10px;padding-bottom:10px;padding-right:10px;padding-left:10px;text-align:center;background: #015289;'>"
correo="$correo<div class='table' style='max-width: 600px; margin:0 auto;'>"
correo="$correo<div class='td w50p vam' style='vertical-align:middle;'>"
correo="$correo<img alt='SIUA' border='0' class='pb10 des-mauto des-pb0' src='https://siua.ac.cr/img/logo.png' style='display:block;border:0;padding-bottom:10px;margin:0 auto; display: block; color: #ffffff; ' width='125'>"
correo="$correo</div>"
correo="$correo<div class='td w50p vam des-tar' style='vertical-align:middle;'>"
correo="$correo<p class='white' style='margin:0;font-size:16px;font-family: Helvetica, Arial, sans-serif;color:#ffffff;'>"
correo="$correo Unidad de Gestión e Innnovación Tecnológica"
correo="$correo</p>"
correo="$correo</div>"
correo="$correo</div>"
correo="$correo</div>"
correo="$correo<div class='frame' style='background:#F8F8F8;'>"
correo="$correo<div class='pl15 pr15 pt35 des-pt50 pb25 des-pb50' style='padding-right:15px;padding-left:15px;padding-bottom:25px;padding-top:35px;'>"
correo="$correo<div class='wrapper pt35 pb35 pl35 pr35 box' style='padding-top:35px;padding-bottom:35px;padding-right:35px;padding-left:35px;max-width:600px;margin:0 auto;text-align:center;mso-element-frame-width:800px;mso-element:para-border-div;mso-element-left:center;mso-element-wrap:no-wrap-beside;mso-padding-top-alt:50px;background:#ffffff;border-radius:10px;'>"
correo="$correo<h2 class='fsz30 lh36 bold pt25 pb15 mso-mb15' style='font-family:Helvetica, Arial, sans-serif;margin:0;padding-bottom:15px;padding-top:25px;color:#353a3e;font-family:Helvetica, Arial, sans-serif;font-weight:bold;font-size:30px;line-height:36px;mso-margin-bottom-alt:15px;'>"
correo="$correo IPs Incluidas en IPSET: 'ips_blacklist PROXMOX'"
correo="$correo</h2>"
correo="$correo<p class='fsz16 lh24 mso-mb25' style='margin:0;color:#777777;font-family:Helvetica, Arial, sans-serif;font-size:16px;line-height:24px;mso-margin-bottom-alt:25px;'>"
correo="$correo A continuación se listan las nuevas direcciones IP's que ha sido agregadas!"
correo="$correo<br><br>"
correo="$correo<table style='width:100%; background-color:#FFFFFF;border-collapse: collapse;align:center'>"
correo="$correo<tr style='text-align:center; background-color:#015289;color:#ffffff;'>"
correo="$correo<td>IP</td>"
correo="$correo<td>Fecha y Hora</td>"
correo="$correo<td>Organización</td>"
correo="$correo</tr>"

ip_agregadas=""
for ((j=0; j<${#IPS[@]}; j++ ));
do

if grep -q ${IPS[$j]} <<< "$archivo_cluster"; then
        printf "${IPS[$j]}\t\t EXISTE\n"
	#break
else
        sed -i '
        /IPSET ips_blacklist/ {
        n
        a\'${IPS[$j]}' # '${IPS[$j+1]}' '${IPS[$j+2]}' '${IPS[$j+3]}'
        }' $cluster_file
        printf "${IPS[$j]}\t\t INCLUIDA CON EXITO!\n"
	ip_agregadas="$ip_agregadas<tr style='text-align:center'><td>${IPS[$j]}</td><td>${IPS[$j+1]}</td><td>${IPS[$j+2]} ${IPS[$j+3]}</td></tr>"

fi
        j=$((j+3)) #incremento de fecha/Nombre_Pais/Organizacion


done
printf "\n"
printf "*****************************************\n"
printf "FIN DE PROCESAMIENTO\n"
printf "*****************************************\n"

correo="$correo $ip_agregadas"
correo="$correo</table>"
correo="$correo<a class='cta fsz18' href='#' style='font-family: Helvetica, Arial, sans-serif;font-weight:normal;color:#ffffff;text-decoration:none;border-radius:30px;padding:15px 30px;display:inline-block;font-weight:bold;mso-padding-alt:0px;margin-top:20px;font-size:18px;box-shadow:0 15px 35px rgba(50,50,93,.1), 0 5px 15px rgba(0,0,0,.07);background-color: #f36c5e; border: 1px solid #f36c5e; mso-border-alt: 8px solid #f36c5e;' target='_blank'>"
correo="$correo Consultar Lista completa"
correo="$correo</a>"
correo="$correo</p>"
correo="$correo</div>"
correo="$correo</div>"
correo="$correo</div>"
correo="$correo</body>"
correo="$correo</html>"



echo $correo | mail \
-a "From: interuniversitariadealajuela@gmail.com" \
-a "MIME-Version: 1.0" \
-a "Content-Type: text/html" \
-s "[CRON/F/$servidor_atacado]" \
interuniversitariadealajuela@gmail.com

# Reestablecemos el valor del $IFS a como estaba antes.
IFS=OLDIFS
